searchNodes=[{"ref":"Docception.html","title":"Docception","type":"module","doc":"Main Docception library. This library is to be used by Mix.Tasks.Docception."},{"ref":"Docception.html#run/2","title":"Docception.run/2","type":"function","doc":"Main entry point. Raises This function raises Docception.Error on errors."},{"ref":"Docception.Error.html","title":"Docception.Error","type":"exception","doc":"An error during Docception."},{"ref":"Mix.Tasks.Docception.html","title":"Mix.Tasks.Docception","type":"task","doc":"Docception -- run doctests on arbitrary markdown files Usage mix docception markdown-files"},{"ref":"Mix.Tasks.Docception.html#run/1","title":"Mix.Tasks.Docception.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"readme.html","title":"Docception","type":"extras","doc":"Docception Run doctests on arbitrary markdown files."},{"ref":"readme.html#usage","title":"Docception - Usage","type":"extras","doc":"$ mix docception markdown-files See the example/ project on how to use an alias in mix.exs to run Docception with mix test."},{"ref":"readme.html#installation","title":"Docception - Installation","type":"extras","doc":"def deps do [ {:docception, &quot;~&gt; 0.3&quot;, runtime: false} ] end"},{"ref":"readme.html#disclaimer","title":"Docception - Disclaimer","type":"extras","doc":"This tool executes any Elixir doctest it encounters (think eval). Ensure that it does not encounter any harmful code!"},{"ref":"readme.html#example","title":"Docception - Example","type":"extras","doc":"This file can also be checked with docception. The following example is run through doctest and results in an error: iex&gt; :hello :crash $ mix docception README.md ** (ExUnit.AssertionError) Doctest failed code: :hello === :crash left: :hello right: :crash The following example works: iex&gt; :hello :hello"},{"ref":"readme.html#todos","title":"Docception - TODOs","type":"extras","doc":"[x] Clean up temporary directory where .beam files are stored [x] Do not hard-code the temporary directory [x] Fix &quot;wrong indent&quot; warnings for heredocs [x] Try to fix wrong line number reports (the offset is always the same!) [x] Check if this also works when a doctest refers to dependencies of the project [x] Document how to use it with an alias in order to simplify running it in CI [x] Publish [ ] Determine how to ensure that errors are written before the task ends; avoid stopping ex_unit in mix task. The root cause of this is [`ExUnit.CLIFormatter`](https://hexdocs.pm/ex_unit/ExUnit.CLIFormatter.html). The formatter writes the error message. Docception can possibly exit before the formatter is done writing. This could be solvable by using a wrapper around [`ExUnit.CLIFormatter`](https://hexdocs.pm/ex_unit/ExUnit.CLIFormatter.html) as a custom formatter instead. This custom formatter would then be shut down manually. Alas, I did not find a way to inject such a custom formatter. [ ] Check if anybody is actually interested in this"},{"ref":"readme.html#how","title":"Docception - How..?","type":"extras","doc":"Docception&#39;s approach is pretty simple: Read in a markdown file Create an Erlang Form that makes the file look like something that can be executed. Add a module attribute Export an __info__/1 function which wraps module_info/1 Compile that thing into a binary Store the resulting .beam in the filesystem to make Code.fetch_docs/1 work Call into the undocumented-and-totally-not-for-public-use ExUnit.DocTest.__doctests__/1 function For each of the quoted doctests, spawn a process and call let it run the quoted doctest Gather the results and raise on error So, except for calling into __doctests__/1, this is pretty straight forward. Note that the implementation relies heavily on the hard work that went into elixir_erl.erl from Elixir itself. Docception needs to create a binary where the &#39;Docs&#39; chunk matches such chunks as generated by elixir_erl.erl."}]